
import FIFO::*;

import AudioProcessorTypes::*;

module mkAudioPipeline
    // interface:
        (AudioProcessor);

    FIFO#(AudioProcessorUnit) infifo <- mkFIFO();
    FIFO#(AudioProcessorUnit) outfifo <- mkFIFO();

    rule process (True);

        if (infifo.first() matches tagged Sample .sample)
        begin
            $display("%h", sample);
        end
        else
        begin
            $display("End of Input");
        end

        infifo.deq();
        outfifo.enq(infifo.first());
    endrule

    method Action putSampleInput(AudioProcessorUnit in);
        infifo.enq(in);
    endmethod

    method ActionValue#(AudioProcessorUnit) getSampleOutput();
        outfifo.deq();
        return outfifo.first();
    endmethod

endmodule

